
#include "fileabstraction.hpp"

FileAbstraction::FileAbstraction()
{
    // empty on purpose
}

FileAbstraction::~FileAbstraction()
{
    this->close();
}


bool FileAbstraction::open(std::string path)
{
    std::cout<< "Open file at path="<<path<< std::endl;

    file_type = FileAbstraction::FILE_TYPE_DECOMPRESSED;
    std::cout << "FileAbstraction: read normal file"<< path<< std::endl;

    this->file_decompressed.open(path);
    this->file_name = path;

    return this->is_ok();
}

bool FileAbstraction::is_ok()
{

    if( file_type == FileAbstraction::FILE_TYPE_DECOMPRESSED )
    {
        if( this->file_decompressed.bad() || this->file_decompressed.fail() || !this->file_decompressed.is_open())
        {
            return false;
        }

        std::cout << "is decompressed, all seems ok"<< std::endl;
    }

    return true;
}

std::string FileAbstraction::get_line(int* is_eof)
{
    if(file_type== FileAbstraction::FILE_TYPE_DECOMPRESSED)
    {
        std::string str;
        if( std::getline(this->file_decompressed, str) )
        {
            *is_eof = 0;
            return str;
        }

        *is_eof = 1;
        return "";
    }


    return "";
}

void FileAbstraction::close()
{

    if(file_type == FileAbstraction::FILE_TYPE_DECOMPRESSED)
    {
        if(this->file_decompressed.is_open())
        {
            this->file_decompressed.close();
        }
    }
}


