
#ifndef __FILE_ABSTRACTION_HPP__
#define __FILE_ABSTRACTION_HPP__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <limits.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <string>
#include <iostream>
#include <fstream>

#include<queue>

#include "../util/util.hpp"


/**
 * @brief The FileAbstraction class
 *
 * The class FileAbstraction is a layer of abstraction when reading a file storing a graph.
 * Its intention was to support compressed files (.zip files). But due to slow performance
 * when reading the file, this support was dropped and only decompressed txt files can be read from disk.
 *
 */
class FileAbstraction
{

public:
    FileAbstraction();
    ~FileAbstraction();

    bool open(std::string path);

    bool is_ok();

    std::string get_line(int* is_eof);

    void close();

    std::string file_name;

private:

    int file_type;
    static const int FILE_TYPE_DECOMPRESSED = 0;

    std::ifstream file_decompressed;

};


#endif
