

#ifndef __FILE_LOADER_HPP__
#define __FILE_LOADER_HPP__

#include <string>
#include <cstdint>
#include <limits>


#include "../util/graph.hpp"

/**
 * @brief The FileLoader class
 * Abstract class used for all file-loaders as an interface.
 *
 */
class FileLoader
{
public:
    FileLoader();
    ~FileLoader();
    virtual WEdgeList* load(std::string path, bool rand_weights, uint32_t max_w) = 0;
    virtual EdgeList* uload(std::string path) = 0;

    static std::string get_file_ending();

    /**
     * @brief gen_random_number
     * Random number generator for edge weights, such that there is no overflow in any case using "int" values
     * @param n
     * @param m
     * @return
     */
    uint32_t gen_random_number(uint32_t n, uint32_t m);

};


#endif
