
#include "inputgenerator.hpp"

InputGenerator::InputGenerator()
{
    // empty on purpose
}


InputGenerator::~InputGenerator()
{
    // empty on purpose
}

WEdgeList* InputGenerator::load(std::string path, bool rand_weights, uint32_t max_w)
{
    FileAbstraction fa;
    fa.open(path);

    std::string file_name = fa.file_name;
    fa.close();

    if( Util::has_suffix(file_name, TsvFileLoader::get_file_ending()) )
    {
        TsvFileLoader loader;
        return loader.load(path, rand_weights, max_w);
    }

    if(Util::has_suffix(file_name, MetisFileLoader::get_file_ending()))
    {
        MetisFileLoader loader;
        return loader.load(path, rand_weights, max_w);
    }


    return nullptr;
}

EdgeList* InputGenerator::uload(std::string path)
{
    FileAbstraction fa;
    fa.open(path);

    std::string file_name = fa.file_name;
    fa.close();

    if( Util::has_suffix(file_name, TsvFileLoader::get_file_ending()) )
    {
        TsvFileLoader loader;
        return loader.uload(path);
    }

    if(Util::has_suffix(file_name, MetisFileLoader::get_file_ending()))
    {
        MetisFileLoader loader;
        return loader.uload(path);
    }


    return nullptr;
}
