#ifndef __INPUT_GENERATOR_HPP__
#define __INPUT_GENERATOR_HPP__


#include <string>

#include "../util/graph.hpp"
#include "../util/util.hpp"
#include "metisfileloader.hpp"
#include "tsvfileloader.hpp"

#include "fileabstraction.hpp"

/**
 * @brief The InputGenerator class
 *
 * Class responsible as a wrapper for reading files (and determining which loader to use dependent on file ending).
 * We can read files stored in the metis or tsv format (see metisfileloader and tsvfileloader).
 *
 */
class InputGenerator
{
public:
    InputGenerator();
    ~InputGenerator();

    WEdgeList* load(std::string path, bool rand_weights, uint32_t max_w);
    EdgeList* uload(std::string path);

};

#endif
