
#ifndef __METIS_FILE_LOADER_HPP__
#define __METIS_FILE_LOADER_HPP__

#include <string>
#include <cstdint>
#include <vector>
#include <sstream>
#include <fstream>
#include <cstddef>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>


#include "../util/graph.hpp"
#include "../util/util.hpp"
#include "fileloader.hpp"
#include "fileabstraction.hpp"


/**
 * @brief The MetisFileLoader class
 *
 * Fileloader for Graphs in the Metis file format
 * See https://www.cc.gatech.edu/dimacs10/data/manual.ps and https://www.cc.gatech.edu/dimacs10/downloads.shtml
 *
 * We simply assume that all Metis files end with ".graph".
 */
class MetisFileLoader : public FileLoader
{

public:
    MetisFileLoader();
    ~MetisFileLoader();
    WEdgeList* load(std::string path, bool rand_weight, uint32_t max_w);
    EdgeList* uload(std::string path);
    static std::string get_file_ending();

private:
    void* load_any(std::string path, int flag, uint32_t max_w);

};

#endif
