
#ifndef __TSV_FILE_LOADER_HPP__
#define __TSV_FILE_LOADER_HPP__

#include <algorithm>
#include <string>
#include <cstdint>
#include <vector>
#include <sstream>
#include <fstream>
#include <cstddef>
#include <iostream>

#include "fileloader.hpp"
#include "../util/util.hpp"
#include "fileabstraction.hpp"


/**
 * @brief The TsvFileLoader class
 *
 * TsvFileLoader class, for TSV files (tab separated values)
 *
 * See http://konect.uni-koblenz.de/ to get files
 *
 * We assume that these files end in .tsv and have the format
 * nid1 nid2 eweight
 * all other values are ignored, lines starting with % are ignored
 */
class TsvFileLoader : public FileLoader
{
public:
    TsvFileLoader();
    ~TsvFileLoader();
    WEdgeList* load(std::string path, bool rand_weights, uint32_t max_w);
    EdgeList* uload(std::string path);
    static std::string get_file_ending();

private:
    void* load_any(std::string path, int flag, uint32_t max_w);

};


#endif
