
#include <stdio.h>
#include <string>
#include <stdlib.h>
#include <time.h>

#include <iostream>

#include "microbench/microbench.hpp"


/**
 * In this main function, we measure micro-benchmarks on the FPGA.
 * These values are required as base-lines. However, the implementation
 * of microbench and the according verilog has not been finished, such that these
 * results are not used in the paper and are left in the code for completeness.
 * Feel free to use it as basis for your own micro-benchmarks.
 */
int main(int argc, char** argv)
{
    puts("Start of program\n");

#ifdef FPGA_FLAG
    if(argc <= 4)
    {
        return 0;
    }


    uint32_t seed = time(NULL);
    std::cout << "seed="<< seed<<std::endl;
    srand (seed);

    auto mb = new MicroBench();

    uint32_t num_cache_lines = atoi( argv[1] );
    uint32_t ncl_latency = atoi(argv[2]);
    uint32_t timeout_in_cycles = atoi(argv[3]);
    uint32_t num_rep = atoi(argv[4]);

    Latency l;
    for(int i = 0; i < num_rep; i++)
    {
        mb->run( num_cache_lines, ncl_latency, timeout_in_cycles, &l );
    }
    mb->compute_results(&l);

    sleep(10);

#endif
    puts("End of main");

    return 0;
}

