
#ifndef __MCM_LEMON_HPP__
#define __MCM_LEMON_HPP__

#include "mcmsolver.hpp"


#include "../runconfig/commonconfig.hpp"
#include "../solver/solver.hpp"

#include <vector>

#include <lemon/matching.h>

/**
 * @brief The MCMLemonSolver class
 *
 * This class is a wrapper for the Lemon Graph Library, such we can use the same interface for all
 * maximum cardinality matching algorithms.
 * Basically, the class converts the input in a format such that Lemon can process it to compute
 * the maximum cardinality matching of the input graph.
 */
class MCMLemonSolver : public MCMSolver
{
public:
    MCMLemonSolver();
    ~MCMLemonSolver();

    void* solve(void* pinput, Timing* timer, RunParams* rp);

    double get_guarantee(RunParams* rp);

    std::string get_solver_name();
};

#endif
