
#include "mcmserial.hpp"


MCMSerial::MCMSerial()
{
    // empty on purpose
}

MCMSerial::~MCMSerial()
{
    // empty on purpose
}

void* MCMSerial::solve(void* pinput,  Timing* timer, RunParams* rp)
{
    EdgeList* input = (EdgeList*)pinput;

    uint32_t timing_prefix_id = timer->startTiming();

    auto M = new std::vector<Edge>();
    std::vector<bool> vertex_set(input->n+1, false);

    timer->endTiming(timing_prefix_id, "prefix", false);

    uint32_t timing_main_loop_id = timer->startTiming();
    uint64_t result_n = 0;
    for(uint64_t i = 0; i < input->m; i++)
    {
        Edge e = input->edge->at(i);

        // add only to M, if we would still have a matching
        if( !vertex_set[e.u] && !vertex_set[e.v] )
        {
            vertex_set[e.u] = true;
            vertex_set[e.v] = true;
            result_n = result_n+2;

            M->push_back(e);
        }
    }
    timer->endTiming(timing_main_loop_id, "main_loop", false);

    uint32_t timing_preamble_id = timer->startTiming();
    EdgeList* result = (EdgeList*) malloc(sizeof(EdgeList));
    result->m = M->size();
    result->n = result_n;
    result->edge = M;
    timer->endTiming(timing_preamble_id, "preable", false);

    return result;
}

double MCMSerial::get_guarantee(RunParams * rp)
{
    return 2.0f;
}

std::string MCMSerial::get_solver_name()
{
    return "mcm_serial";
}
