
#ifndef __MCM_SERIAL_HPP__
#define __MCM_SERIAL_HPP__

#include "mcmsolver.hpp"
#include "../solver/solver.hpp"
#include "../runconfig/commonconfig.hpp"

#include <vector>

/**
 * @brief The MCMSerial class
 *
 * Serial implementation of maximal cardinality matching.
 * The function guarantees to provide a 2-approximation to the maximum cardinality matching.
 *
 */
class MCMSerial : public MCMSolver
{
public:
    MCMSerial();
    ~MCMSerial();

    void* solve(void* pinput,  Timing* timer, RunParams* rp);

    double get_guarantee(RunParams* rp);

    std::string get_solver_name();
};

#endif
