
#ifndef __MCM_SOLVER_HPP__
#define __MCM_SOLVER_HPP__

#include "../solver/solver.hpp"
#include "../runconfig/commonconfig.hpp"

#include "../util/graph.hpp"
#include "../util/timing.hpp"

#include <string>

/**
 * @brief The MCMSolver class
 *
 * Parent class for all MCM solvers (classes which solve the maximum cardinality matching or
 * compute an approximation to the MCM problem).
 *
 */
class MCMSolver : public Solver
{
public:
    int get_input_type();

    std::string get_problem_name();

    void delete_output(void* poutput);

    void delete_input(void* pinput);

    bool is_result_correct(void* ptruth, void* pcomputed, RunParams* rp);

    static uint64_t get_matching_cardinality(EdgeList* matching);
};

#endif
