
#ifndef __MWM_OPENMP_SIMPLE_CROUCH_HPP__
#define __MWM_OPENMP_SIMPLE_CROUCH_HPP__

#include "mwmsolver.hpp"
#include <omp.h>

#include "../util/bitvector.hpp"

/**
 * @brief The MWMCrouchSerialOpenMPSimple class
 *
 * OpenMP implementation of the algorithm of Crouch and Stubbs.
 * The basic idea is to compute all maximal cardinality matchings in parallel and merge the intermediate
 * result sequentially for the final MWM approximation.
 *
 */
class MWMCrouchSerialOpenMPSimple : public MWMSolver
{
public:
    MWMCrouchSerialOpenMPSimple();
    ~MWMCrouchSerialOpenMPSimple();

    void* solve(void* pinput, Timing* timer, RunParams* rp);

    double get_guarantee(RunParams* rp);

    std::string get_solver_name();

    double get_min_epsilon();

    double get_min_delta();

};

#endif
