
#ifndef __MWM_SERIAL_CROUCH_HPP__
#define __MWM_SERIAL_CROUCH_HPP__

#include "mwmsolver.hpp"

#include "../util/bitvector.hpp"

/**
 * @brief The MWMCrouchSerial class
 *
 * Sequential implementation of the maximum weighted matching approximation algorithm of
 * Crouch and Stubbs.
 */
class MWMCrouchSerial : public MWMSolver
{
public:
    MWMCrouchSerial();
    ~MWMCrouchSerial();

    void* solve(void* pinput, Timing* timer, RunParams* rp);

    double get_guarantee(RunParams* rp);

    std::string get_solver_name();

    double get_min_epsilon();

    double get_min_delta();

};

#endif
