#ifndef __MWM_SERIAL_HPP__
#define __MWM_SERIAL_HPP__


#include <cmath>
#include <ctgmath>
#include <stack>
#include <queue>
#include <list>

#include "mwmsolver.hpp"

/**
 * @brief The MWMGhaffariSerial class
 * Serial implementation of the MWM algorithm by Mohsen Ghaffari,
 * https://pdfs.semanticscholar.org/1c4f/09adbc5d8b3db4de9f04468b87d2184b8187.pdf
 */
class MWMGhaffariSerial : public MWMSolver
{
public:
    MWMGhaffariSerial();
    ~MWMGhaffariSerial();

    void* solve(void* pinput, Timing* timer, RunParams* rp);

    double get_guarantee(RunParams* rp);

    std::string get_solver_name();

    double get_min_epsilon();

    double get_min_delta();
};


#endif
