

#ifndef __MWM_SOLVER_HPP__
#define __MWM_SOLVER_HPP__

#include <string>

#include "../solver/solver.hpp"
#include "../util/graph.hpp"
#include "../util/timing.hpp"
#include "../runconfig/commonconfig.hpp"


/**
 * @brief The MWMSolver class
 *
 * Parent class for all mwm solvers.
 */
class MWMSolver : public Solver
{
public:
    int get_input_type();

    std::string get_problem_name();

    void delete_output(void* poutput);

    void delete_input(void* pinput);

    bool is_result_correct(void* ptruth, void* pcomputed, RunParams* rp);

    static uint64_t get_matching_weight(WEdgeList* matching);

    static uint64_t get_matching_cardinality(WEdgeList* matching);
};

#endif
