
#ifndef __COMMON_CONFIG_HPP__
#define __COMMON_CONFIG_HPP__

#include "../../rapidjson/document.h"
#include "../../rapidjson/writer.h"
#include "../../rapidjson/stringbuffer.h"
#include "../../rapidjson/document.h"
#include "../../rapidjson/istreamwrapper.h"

#include <vector>
#include <string>



#include "../util/graph.hpp"

#include "../solver/solver.hpp"

/**
 * @brief The CommonConfig class
 * Parent class of PerformanceConfig and UnitTestConfig. Since they may share a lot (file parsing etc),
 * these methods are aggregated in here.
 *
 */
class CommonConfig
{
public:
    CommonConfig(std::string path, uint32_t seed);
    ~CommonConfig();
    void register_function(Solver* solver);

    virtual void execute() = 0;


protected:
    std::string file_path; // the input file
    std::string experiment_name; // the experiment name

    std::vector<RunParams> run_params; // the list of run parameters, on which we run
    std::vector<Solver*> solvers;

    uint32_t seed;
};

#endif
