
#ifndef __PERFORMANCE_CONFIG_HPP__
#define __PERFORMANCE_CONFIG_HPP__


#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <stdexcept>

#include <unistd.h>

#include <stdio.h>
#include <dirent.h>


#include "../solver/solver.hpp"
#include "../mwmsolver/mwmsolver.hpp"
#include "../io/inputgenerator.hpp"
#include "../util/timing.hpp"

#include "commonconfig.hpp"



/**
 * @brief The PerformanceConfig class
 *
 * It handles the performance measurements and repeats the experiments according to the given parameters.
 */
class PerformanceConfig : public CommonConfig
{
public:
    PerformanceConfig(std::string file_path, uint32_t seed);
    ~PerformanceConfig();

    static const std::string FILE_EXTENSION;
    void execute();

private:

    std::string output_folder; // the output folder
    uint32_t fpga_frequency;
    bool delete_folder;

};


#endif
