
#ifndef __RUN_CONFIG_HPP__
#define __RUN_CONFIG_HPP__

#include <string>
#include <vector>
#include <sys/stat.h>
#include <iostream>
#include <sys/types.h>
#include <dirent.h>



#include "performanceconfig.hpp"
#include "unittestconfig.hpp"

#include "../util/util.hpp"
#include "../mwmsolver/mwmsolver.hpp"
#include "../solver/solver.hpp"

/**
 * @brief The RunConfig class
 *
 * Class which determines, given a run-configuration, if it is for performance evaluation
 * or to test the implemented algorithms.
 */
class RunConfig
{

public:
    RunConfig(std::string path, uint32_t seed);
    RunConfig(std::vector< std::string> ppaths, uint32_t seed);
    ~RunConfig();


    void execute();
    void register_function_exact(Solver *solver);
    void register_function(Solver *solver);


private:
    void execute_file(std::string file_path);

    std::vector<Solver*> solvers;
    Solver* solver_exact;

    std::vector<std::string> paths;
    uint32_t seed;

};

#endif
