
#ifndef __UNIT_TEST_CONFIG_HPP__
#define __UNIT_TEST_CONFIG_HPP__


#include "commonconfig.hpp"

#include "../solver/solver.hpp"

#include "../mwmsolver/mwmsolver.hpp"
#include "../mcmsolver/mcmsolver.hpp"

#include "../io/inputgenerator.hpp"
#include "../util/timing.hpp"

#include "../util/color.hpp"

/**
 * @brief The UnitTestConfig class
 *
 * Given an input graph (or multiple input graphs), the class computes the excat
 * solution and compares it to the ouput of the other algorithms.
 */
class UnitTestConfig : public CommonConfig
{
public:
    UnitTestConfig(std::string file_path, uint32_t seed);
    ~UnitTestConfig();

    static const std::string FILE_EXTENSION;
    void register_function_exact(Solver* solver);

    void execute();

private:
    Solver* exact_solver;
};

#endif
