
#ifndef __BIT_VECTOR_HPP__
#define __BIT_VECTOR_HPP__


#include <iostream>
#include <exception>
#include <stdexcept>
#include <memory>
#include <math.h>


/**
 * @brief The BitVector class
 *
 * Implementation of a bit-vector to omit space-overhead as in char vectors.
 *
 */
class BitVector
{
public:
    BitVector(uint32_t nelems);
    ~BitVector();

    uint8_t operator[] (const uint32_t& pos) const;

    uint8_t get (const uint32_t& pos) const;

    void set (const uint32_t& pos, const bool& bit);

    void set_true(const uint32_t&pos);

    uint8_t get_and_set_true(const uint32_t& pos);


private:
    uint32_t  size;
    uint8_t* array;

};


#endif
